`timescale 1ns/1ps

module cmos_capture_rgb565_tb;

	reg cmos_pclk;
	reg Rst_n;
	reg Init_Done;
	reg cmos_vsync;
	reg cmos_href;
	reg [7:0] cmos_data;
	wire  fifo_aclr;
	wire fifo_wrreq;
	wire [7:0] fifo_wrdata;

	cmos_capture_rgb565 DUT(
		.cmos_pclk(cmos_pclk),
		.Rst_n(Rst_n),
		.Init_Done(Init_Done),
		.cmos_vsync(cmos_vsync),
		.cmos_href(cmos_href),
		.cmos_data(cmos_data),
		.fifo_aclr(fifo_aclr),
		.fifo_wrreq(fifo_wrreq),
		.fifo_wrdata(fifo_wrdata)
	);
	
	integer i;
	
	always #10 cmos_pclk = ~cmos_pclk;
	
	initial begin
		cmos_pclk = 1;
		Rst_n = 0;
		Init_Done = 0;
		cmos_vsync = 1;
		cmos_href = 0;
		cmos_data = 8'd0;
		
		#200
		Rst_n = 1;
		
		Init_Done = 1;
		cmos_vsync = 0;
		
		cmos_href = 1;
		for (i = 0; i < 20; i = i + 1) begin
			cmos_data = {$random} % 256;
			#20;
		end
		cmos_href = 0;
		#200;
		
		cmos_href = 1;
		for (i = 0; i < 20; i = i + 1) begin
			cmos_data = {$random} % 256;
			#20;
		end
		cmos_href = 0;
		#200;
		
		cmos_href = 1;
		for (i = 0; i < 20; i = i + 1) begin
			cmos_data = {$random} % 256;
			#20;
		end
		cmos_href = 0;
		cmos_vsync = 1;
		#20;
		cmos_vsync = 0;
		
		#2000;
		$stop;
	end



endmodule
